(((kind "manual-section") (section-title "Practical Introduction") (section-body "When you have installed LAML on your computer you also have a full installation of
             the Scheme elucidator, including Emacs support of elucidative programming.<p>The emacs command M-x make-elucidator helps you establish a fresh elucidator. Follow
             the direction given from this command. From Emacs
             type C-e ? to get brief help on the Elucidator editor commands. For more complete information
             see the section 'Elucidator editor support using Emacs' in this manual.<p>The command M-x elucidate (or C-e C-o) on an elucidator buffer activates the Elucidator from Emacs. The Elucidator is the tool
             which produces the WWW pages which presents the documentation bundle in an Internet browser.
             The main file is found in html/index.html. In addition, if the setup file is called f.laml,
             the main file is available as f.html in the source directory.<p>When you read the Elucidator WWW pages navigate to the Help page via one of the 'Question Mark Icons'
             to get help on the possibilities offered by the Elucidator tool.")) ((kind "manual-section") (section-title "Forms in the setup file") (section-body "The setup file must be a file with laml file extension. This is the file which
  connects all the files in a documentation bundle. In this section we will describe the important and primary
  functions and forms, which may be found in the setup file. In the next section we document a number of less important
  forms. We start with the most important setup forms")) ((kind "manual-page") (title "documentation-intro") (form (documentation-intro title author email affiliation abstract)) (description "Define the documentation introduction in terms of a title, author, email, affiliation, and abstract") (parameters (parameter "title" "The title of the documentation (a string)") (parameter "author" "The author of the documentation (a string)") (parameter "email" "The email address of the author (a string)") (parameter "affliation" "The affiliation of the author (a string)") (parameter "abstract" "The abstract of the documentation (a string)"))) ((kind "manual-page") (title "program-source") (form (program-source . elements)) (description "Define a program source file to be part of this documentation bundle.
               A program source file is defined in terms of a key name, a file location, the programming language used,
               and a group name. The key name nick names the file for use in an elucidative program (in order
               to avoid using the full file name or file path). The file location should be the full
               path to the program file (including extension). The programming language must be Scheme.
               Finally, group defines the belonging of this source file to a group of logically related 
               source files. This is used for background coloring purposes.
               One or more program-source forms may be present the the LAML setup file") (parameters (parameter "elements" "an element may be a key, file-location and language forms")) (cross-references (internal-references "Constituents" "key" "file-location" "language" "group"))) ((kind "manual-page") (title "manual-source") (form (manual-source . elements)) (description "Declare a LAML manual file to be part of the documentation. 
               This causes links to be created from the programs to relevant manual entries.
               File-location clauses must address '-.lsp' files which are generated by the manual document style.") (parameters (parameter "elements" "an element may be a file-location or a url-location")) (cross-references (internal-references "Constituents" "file-location" "url-location"))) ((kind "manual-page") (title "begin-documentation") (form (begin-documentation)) (description "Starts the section of the documentation in which documentation-entry and documentation-section
               forms may appear.")) ((kind "manual-page") (title "end-documentation") (form (end-documentation)) (description "Ends the section of the documentation which contains documentation-entry and documentation-section forms") (misc "This form initiates far the majority of the processing of the Elucidator. As such, end-documentation is
        a very important form")) ((kind "manual-page") (title "documentation-from") (form (documentation-from documentation-file)) (description "Parses and extracts documentation from a separate, textual format which we define in a subsequent section 
               of this manual. 
               The documentation-file is opened in the source-directory.
               This form is entirely equivalent to a number of of documentation-entry and documentation-section forms.
               In fact, the extracted information is passed into the documentation-entry and documentation-section forms,
               after which these are evaluated by means of the Lisp eval.") (parameters (parameter "documentation-file" "The name of the documentation file (a string). No path information must be present.
                                   However, a possible file extension must be included.")) (cross-references (internal-references "See also" "set-source-directory") (internal-references "Equivalent Lisp forms" "documentation-entry" "documentation-section"))) ((kind "manual-page") (title "elucidator-verbose-mode") (form elucidator-verbose-mode) (description "A variable controling the amount of output written while eludicating a documentation bundle.
               The type of the variable is boolean. If #t, a bunch of output is written on standard output 
               while processing. The default value is #t.") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "set-source-directory") (form (set-source-directory dir)) (description "Defines the source directory to be dir. The source directory is the directory which
               contains the documentation laml setupfile, and the path typically ends in doc. Ends in a slash.
               You must setup the source directory by means of this function.") (parameters (parameter "dir" "The full path of the directory with the laml setup file"))) ((kind "manual-page") (title "set-documentation-name") (form (set-documentation-name name)) (description "Define the name of the documentation. Per convention, this is the same
               as the file name of the laml file, without extension.") (parameters (parameter "name" "The name of the documentation (a string)"))) ((kind "manual-page") (title "make-all-indexes") (form (make-all-indexes)) (description "Ask for generation of both duplicate name index, cross reference index, and defining name index") (cross-references (internal-references "Opposite function" "make-no-indexes")) (misc "This variable assigns values to the boolean variables make-duplicated-name-index?, make-cross-reference-index?,
        and make-defining-name-index?")) ((kind "manual-page") (title "make-no-indexes") (form (make-no-indexes)) (description "Ask for generation of no indexes") (cross-references (internal-references "Opposite function" "make-all-indexes")) (misc "This variable assigns values to the boolean variables make-duplicated-name-index?, make-cross-reference-index?,
        and make-defining-name-index?")) ((kind "manual-page") (title "process-only") (form (process-only . source-keys)) (description "Controls which of the sources files to process.
               Only process the sources whose keys are given in the parameter.
               If no parameteres are given, process no sources
               If this form does not appear, process all sources.") (parameters (parameter "source-keys" "a number of source-keys, as specified in the program-source clauses")) (cross-references (internal-references "See also" "program-source"))) ((kind "manual-page") (title "minimum-processing") (form (minimum-processing)) (description "Ask for minimum processing of the documentation bundle.
               This means make no indexes, process no of the source files (but read information from last processing, if any),
               and make no large font source files") (cross-references (internal-references "Opposite function" "maximum-processing"))) ((kind "manual-page") (title "maximum-processing") (form (maximum-processing)) (description "Ask for maximum processing of the documentation bundle.
               This means make all indexes, process all the source files (but read information from last processing, if any),
               and make large font source files") (cross-references (internal-references "Opposite function" "minimum-processing"))) ((kind "manual-page") (title "key") (form (key key-val)) (description "Sets the key to key-val. The key of a program-source is a convenient string which allows us to reference
               to a particular source file without using file name or file path") (parameters (parameter "key-val" "a string")) (pre-condition "Must be part of a program-source form") (cross-references (internal-references "Neighbor forms" "file-location" "language" "group") (internal-references "Part of" "program-source"))) ((kind "manual-page") (title "file-location") (form (file-location path)) (description "Sets the file location of a program source to be path") (parameters (parameter "path" "The full path of a source file in the documentation bundle")) (pre-condition "Must be part of a program-source or manual-source form") (cross-references (internal-references "Neighbor forms" "key" "language" "group") (internal-references "Part of" "program-source" "manual-source"))) ((kind "manual-page") (title "url-location") (form (url-location path)) (description "Sets the url address of a manual-source to be path") (parameters (parameter "path" "The absolute or relative url of a manual HTML file. Relative to the html directory.")) (pre-condition "Must be part of a manual-source form") (cross-references (internal-references "Neighbor forms" "file-location") (internal-references "Part of" "manual-source"))) ((kind "manual-page") (title "language") (form (language lang)) (description "Defines the programming language used in a program source") (parameters (parameter "lang" "a string")) (pre-condition "Must be part of a program-source form") (cross-references (internal-references "Neighbor forms" "key" "file-location" "group") (internal-references "Part of" "program-source"))) ((kind "manual-page") (title "group") (form (group group-name)) (description "Defines the group to which a source file belongs. This is used for
               background coloring purposes.") (parameters (parameter "group-name" "a string")) (pre-condition "Must be part of a program-source form") (cross-references (internal-references "Neighbor forms" "key" "file-location" "language") (internal-references "Part of" "program-source"))) ((kind "manual-section") (section-title "Secondary setup") (section-body "In this section we document a number of less important setup possibilities. ")) ((kind "manual-page") (title "end-file-empty-lines") (form end-file-empty-lines) (description "The number of empty lines in the bottom of an html file,
               Allow navigation to bottom stuf.") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "browser-pixel-width") (form browser-pixel-width) (description "A variable defining the width of the browser in pixels") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "control-frame-pixel-height") (form control-frame-pixel-height) (description "The pixel height of the (top level) control frame") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "p-link-prefix-char") (form p-link-prefix-char) (description "A variable defining the program link prefix character. Default is '{'") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "p-link-suffix-char") (form p-link-suffix-char) (description "A variable defining the program link suffix character. Default is '}'") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "d-link-prefix-char") (form d-link-prefix-char) (description "A variable defining the documentation link prefix character. Default is '['") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "d-link-suffix-char") (form d-link-suffix-char) (description "A variable defining the documentation link prefix character. Default is ']'") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "copy-image-files?") (form copy-image-files?) (description "A variable which controls whether to copy  image icons from the software directory to the source (documentation) directory.") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "make-large-source-files?") (form make-large-source-files?) (description "A boolean variable which controls the generation of a source file with large fonts.") (cross-references (internal-references "Affected by" "minimum-processing" "maximum-processing")) (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "present-hidden-ids?") (form present-hidden-ids?) (description "Controls whether to present the identification of sections and entries, hidden using the background color. 
               If you knows theses are presented, it may be useful to copy them from the browser to the editor during the programming and
               documentation process.
               Thye type of the variable is boolean.") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "source-marker-kind") (form source-marker-kind) (description "A variable which deterimens the 'style' of source markers on the documentation page.
              The value must be one of the symbols as-text, as-colored-text, as-image. as-image is recommended (default).") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "elucidator-marker-char") (form elucidator-marker-char) (description "A char valued variable which defines the character used as source marker char. The default value is '@', which in Scheme is denoted by #\\@") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "alphabetic-cross-reference-index?") (form alphabetic-cross-reference-index?) (description "A boolean variale controlling whether to split the cross reference index in alphabetic files.
               If false, make one large cross reference index.
               Default value is true") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "alphabetic-defined-name-index?") (form alphabetic-defined-name-index?) (description "A boolean variale controlling whether to split the defined name  index in alphabetic files.
               If false, make one large cross reference index.
               Default value is true") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "link-definitions-to-cross-reference-index?") (form link-definitions-to-cross-reference-index?) (description "A boolean variable which controls whether to link from program definitions to
               the corresponding entry in the cross reference index.") (misc "If necessary, set this variable with a Scheme define form")) ((kind "manual-page") (title "elucidator-color-scheme") (form elucidator-color-scheme) (description "An association list that maps group strings to colors. The group string can be defined
               side by side with key, file-location, and language in a program-source form. The
               color can be a LAML color. Typically we use one of the symbolic name documentation-background-color
               or program-background-color-<em>i</em>, <em>i</em> in [1..7].
               ") (cross-references (internal-references "Related form" "program-source")) (misc "Use a define form to set this variable.")) ((kind "manual-page") (title "rs4r-url-prefix") (form rs4r-url-prefix) (description "Define the URL prefix to the LAML distribution directory that contains
               the 'Scheme knowledge'. This is the 'r4rs/ directory in the LAML distribution.
               The value of this varibale should be an absolute or relative file path from
               the elucidator html directory to the 'Scheme knowledge directory'.") (misc "Use a define form to set this variable. Unfortunately, I have used a slightly 
        inconsistent abbreviations for this URL prefix property.")) ((kind "manual-page") (title "elucidator-home-url") (form elucidator-home-url) (description "Define the home URL of the elucidator.
               This 'home page' may serve as a common page for a number of elucidators.
               If false (#f) no home icon is included.
              ") (misc "Use a define form to set this variable.")) ((kind "manual-page") (title "default-program-font-size") (form default-program-font-size) (description "Set the default font size of the programs presented in this elucidator. 
               The value is either the symbol small or large. Defaults to small") (misc "Use a define form to set this variable.")) ((kind "manual-page") (title "default-table-of-content") (form default-table-of-content) (description "Set the default table of contents of this elucidator.
               Possible values are either the symbol overall or detailed.
               Defaults to overall.") (misc "Use a define form to set this variable.")) ((kind "manual-page") (title "default-program-link") (form default-program-link) (description "A variable that determines the default kind of linking from documentation to program.
               The default is used if no +, *, or - is used as the first character in {...}.
               The value is one of the symbols 'weak, 'strong, or 'none.") (misc "Use a define form to set this variable.")) ((kind "manual-page") (title "manual-frame-from-program") (form manual-frame-from-program) (description "A variable that determines the name of the browser frame used when we address manual
               entries from the program. Possible values are \"documentation-frame\", \"program-frame\",
               or another frame name (causing a new window to be created).") (cross-references (internal-references "Related form" "manual-frame-from-documentation")) (misc "Use a define form to set this variable.")) ((kind "manual-page") (title "manual-frame-from-documentation ") (form manual-frame-from-documentation) (description "A variable that determines the name of the browser frame used when we address manual
               entries from the documentation. This frame is also used to display Scheme manual - R4RS - information.
               Possible values are \"documentation-frame\", \"program-frame\",
               or another frame name (causing a new window to be created).") (cross-references (internal-references "Related form" "manual-frame-from-program")) (misc "Use a define form to set this variable.")) ((kind "manual-section") (section-title "Lisp level documentation functions") (section-body "The functions in this section document the Lisp level documentation-entry and documentation-section functions.
                Normally, these functions are not used. Instead we rely on the simple, textual (and non-Lisp) format
                of documentation found in a separate file. However, it is perfectly possible to avoid the
                separate documentation file, and to use the two functions below (and their constituent forms). In fact,
                the format of the separate, textual documentation file is parsed and transformed to calls of 
                documentation-entry and documentation-section")) ((kind "manual-page") (title "documentation-section") (form (documentation-section . elements)) (description "Define the elements of a documentation section. The possible elements are id, title, and intro, all
               of which are defined in the last part of this section") (parameters (parameter "elements" "constituents of the documentation section ")) (cross-references (internal-references "Constituents forms" "id" "title" "intro") (internal-references "Similar form" "documentation-entry"))) ((kind "manual-page") (title "documentation-entry") (form (documentation-entry . elements)) (description "Define the elements of a documentation entry. An entry is a subsection of a section. The possible elments of an
               entry are id, title, and body") (parameters (parameter "elements" "constituents of the documentation section ")) (cross-references (internal-references "Constituents forms" "id" "title" "body") (internal-references "Similar form" "documentation-section"))) ((kind "manual-page") (title "id") (form (id id-symbol)) (description "Defines the identification of a documentation-entry or documentation-section") (parameters (parameter "id-symbol" "A unique symbol which identifies a documentation-entry or documentation-section")) (cross-references (internal-references "Part of" "documentation-section" "documentation-entry"))) ((kind "manual-page") (title "title") (form (title t)) (description "Defines the title of a documentation-entry or documentation-section") (parameters (parameter "t" "The title (a string)")) (cross-references (internal-references "Part of" "documentation-section" "documentation-entry"))) ((kind "manual-page") (title "body") (form (body b)) (description "Defines the body of a documentation-entry. The body may contain program references in curly brackets {...} and documentation
               references in brackets [...]") (parameters (parameter "b" "The body (a string)")) (cross-references (internal-references "Part of" "documentation-entry"))) ((kind "manual-page") (title "intro") (form (intro i)) (description "Defines the introductory text of a documentation-entry. Also this text may contain program references in curly brackets {...} and documentation
               references in brackets [...]") (parameters (parameter "i" "The introductory text (a string)")) (cross-references (internal-references "Part of" "documentation-section"))) ((kind "manual-section") (section-title "The textual documentation file") (section-body "Here we describe the format of the textual and separate documentation format. The textual format is inserted
                into the documentation by means of the function  <a href = \"#documentation-from\">documentation-from</a> . If the textual documentation form is used, the functions
                defined in the previous sections are typically not used. However, it is perfectly possible to use the textual format (and
                documentation-from) side by side with  <a href = \"#documentation-entry\">documentation-entry</a>  and  <a href = \"#documentation-section forms\">documentation-section forms</a> .
                Such a mixed style may be attractive
                for people who want to take advantage of LAML expressions instead of HTML expressions, which can be used in the textual 
                documentation format.<p>First we describe the documentation intro (corresponding to the function  <a href = \"#documentation-intro\">documentation-intro</a> ):<p><table border = 0><tr><td width = 10 valign = top ></td><td width = * valign = top ><pre>.TITLE       title
.AUTHOR      author
.EMAIL       email
.AFFILIATION affiliation
.ABSTRACT
abstract
.END</pre></td></tr></table><p>After the documentation intro comes a number of documentation sections: 
                (corresponding to the function  <a href = \"#documentation-section\">documentation-section</a> ):<p><table border = 0><tr><td width = 10 valign = top ></td><td width = * valign = top ><pre>.SECTION id
.TITLE title
.BODY
body-text
.END</pre></td></tr></table><p>Finally, in between sections we have documentation entries 
                 (corresponding to the function  <a href = \"#documentation-entry\">documentation-entry</a> )<p><table border = 0><tr><td width = 10 valign = top ></td><td width = * valign = top ><pre>.ENTRY id
.TITLE title
.BODY
body-text
.END</pre></td></tr></table><p>The templates shown above corresponds exactly to the insertions done by the Emacs lisp template functions, which
                 are described in the last part of this manual.<p>Inside the body text of sections and entries you can make links to program fragments, or more precisely, to the definitions in 
                 a Scheme program.<ul><li type = disc>Using the notation <kbd>{+f}</kbd> a weak link to the definition of <kbd>f</kbd> is created. Here we just mention <kbd>f</kbd> without explaining it.</li><li type = disc>Using <kbd>{*f}</kbd> creates a strong link at a place, where <kbd>f</kbd> is explained.</li><li type = disc>Using <kbd>{-f}</kbd> creates a typographical emphasis of <kbd>f</kbd>, but  no linking</li><li type = disc>In all three cases above we can qualify f with a file name. The general format of program reference is<pre>    {modifier-char file $ name} </pre>where modifier is a single key '*', '+', or '-'. File is a key name which refers to a file, as defined in a program-source form. 
                  name is the name of a definition in a Scheme file.</li><li type = disc>The notation <kbd>[d]</kbd> creates a link to another documentation section or entry;
                 <kbd>d</kbd> is the <kbd>id</kbd> if the section/entry.</li></ul><p>If <kbd>{f}</kbd> is used without a leading +, *, or -, the value of the variable <kbd>default-program-link</kbd>
                      determines the default kind of linking from documentation to program. 
                      Possible values of <kbd>default-program-link</kbd> is one of the symbols <kbd>weak</kbd>, <kbd>strong</kbd>, or <kbd>none</kbd>.<p>If <kbd>{f}</kbd>, <kbd>{+f}</kbd>, <kbd>{*f}</kbd>, or <kbd>{file:f}</kbd>  does not refer to a program name in the documentation bundle,
                      as defined by the <kbd>program-source</kbd> clauses, we attempt to link to a manual entry, as defined 
                      by the <kbd>manual-source</kbd> clauses.<p>It is possible to mark a particular place in program by means of a source marker. A source marker in a program must be at a comment place,
                 and it is denoted by <kbd>@</kbd><em>x</em>, where <em>x</em> is a letter in the interval [a..o]. A source marker in a program, such as <kbd>@a</kbd>, must be followed by blank space (a space, CR, etc). Source markers can also be used in the documentation, in which they link to the detailed
                program place via the closest, preceding strong documentation/program link. Make sure that you do not use the same source marker to refer to places in
                different definitions within a single section or entry in the documentation.")) ((kind "manual-section") (section-title "The setup file") (section-body "Here follows an example of a complete setup file. The example is taken from 
                         the from the LAML example directory:<p><table border = 0><tr><td width = 10 valign = top ></td><td width = * valign = top ><font size = 2 color = \"#a64700\"><pre>; The elucidator laml setup file
; Change the capital names

; Load the styles file, hereby defining style function

(load (string-append laml-dir \"laml.scm\"))

(laml-style \"xml-in-laml/elucidator/elucidator\")

; Set the directory in which this file resides.
; The directory ends in a '/'

(set-source-directory (startup-directory))

; Set the name of this file, without extension
(set-documentation-name \"meta-demo\")

; Set the level of processing. With commenting, process all source files.
; (process-only)

; (make-no-indexes)
(make-all-indexes)

(define make-large-source-files? #t)
; (define toc-columns-detail 1) 
; (define present-hidden-ids? #t)
; (define underline-program-links #f)
; (define underline-documentation-links #f)
; (define show-sectional-comment-name #f)

; The RELATIVE (back) path to the r4rs directory, which is located in the root of the LAML distribution.
(define rs4r-url-prefix \"../../../../r4rs/\")

; Do you want an menu like selection of programs?
(define separate-program-menu? #t)

(define elucidator-color-scheme 
  (make-color-scheme 
    \"meta\" program-background-color-1
    \"other\"   program-background-color-2
  ))

(define (laml-source-file f)
  (string-append software-base-directory f))


; Define the sourcefiles in this documentation bundle
(program-source
 (key \"meta-demo\")
 (file-location (laml-source-file \"examples/elucidator/meta-demo/meta-demo.scm\"))
 (language \"scheme\")
 (group \"meta\")
)

(program-source
 (key \"other-source\")
 (file-location (laml-source-file \"examples/elucidator/meta-demo/other-source.scm\"))
 (language \"scheme\")
 (group \"other\")
)


; Define the documentation body, here in terms of a documentation-from clause
(begin-documentation)

  (documentation-from \"meta-demo.txt\")  ; the name of the file can be changed 

(end-documentation)
</pre></font></td></tr></table>")) ((kind "manual-section") (section-title "The program files") (section-body "The program files are normal Scheme files. There are only a few things to observe:<p><ul><li type = disc>There should be no comments in between let, let*, lecrec and the name bindings.</li><li type = disc>There should be no comments in between define and the name (or form) being defined</li></ul><p>In addition the rules about the use of source marker in the scheme program should be observed:<p><ul><li type = disc>Source markers are found in Scheme comments. A source marker is implicitly related to the enclosing, top-level definition.</li><li type = disc>A source marker is of the form @<em>x</em>, where <em>x</em> is a single character in the interval ['a'..'o'].</li><li type = disc>A source marker in a program comment must be followed by a blank character (space, CR, or a similar character).</li><li type = disc>A comment which is started with ::<em>sectional-comment-id</em>::  (a name in double colon) names the subsequent Scheme form(s). Such
               a comment is called a sectional comment.</li></ul>")) ((kind "manual-section") (section-title "An example of a complete documentation file") (section-body "In this section we show an example of complete documentation file. The example is taken from the <a href = \"../../../examples/elucidator/meta-demo/meta-demo.html\">meta demo example</a> in the elucidator example directory.<p><table border = 0><tr><td width = 10 valign = top ></td><td width = * valign = top ><font size = 2 color = \"#0000ff\"><pre>.TITLE       A simple meta demonstration of the Scheme Elucidator
.AUTHOR      Kurt Nrmark
.EMAIL       normark@cs.auc.dk
.AFFILIATION Department of Computer Science, Aalborg University, Denmark
.ABSTRACT
This elucidative program demonstrates the facilities of the Scheme Elucidator.
The program fragments are just simple and well known functions without any coherence
or real value.
.END

-----------------------------------------------------------------------------

.SECTION first-section
.TITLE A section
.BODY
This is section one. Here we can give overview of the subsequent subsections, which we
happen to call entries.
.END

-----------------------------------------------------------------------------

.ENTRY first-entry
.TITLE An introductory entry
.BODY
Here in the first subsection we can introduce the matters. Typically we do not make
very many references to program pieces from the first section.

A documentation bundle is the set of Scheme files, the textual documentation file, and
the LAML setup file.  &lt;p&gt;

We have made the documentation bundle by means of the emacs command M-x make-elucidator. 
This command creates the documentation file, the first program file, and the setup file.
It also creates the necessary and underlying file and directory structures. When we execute
this editor command we are asked to process the LAML file, and to activate another emacs command
setup-elucidator. We just do that.

.END

--------------------------------------------------------------------------------

.ENTRY second-entry
.TITLE The next entry
.BODY
I made this entry via the Emacs command M-x insert-documentation-entry. &lt;p&gt;

In this entry we can start discussing the Scheme program. Just to have something
on the program side, we have made the well-known {-fak} function in meta-demo. So we make
a reference to it. If we have lost the editor context we can always say C-e C-r (or M-x elucidator-reset-elucidator)
to establish the characteristic split view editor panes with documentation in the top window and
program in the bottom window.&lt;p&gt;

Now let us discuss {*meta-demo$fak}. The reference just inserted is conveniently made by selecting
the fak header in the Scheme file and entering C-e C-p (elucidator-program-ref). It turns out that 
this makes a full qualified reference (file and name). The reason is that the editor - at this point in 
time - does not known any thing about {-fak}. If the documentation bundle had been processed (abstracted)
we would have this knowledge. We may change this policy in the future.&lt;p&gt;

We now process the documentation bundle by C-e C-o (or M-x elucidator-elucidate).

.END

--------------------------------------------------------------------------------

.ENTRY third-entry
.TITLE The next steps
.BODY
We now program additional functions in both {meta-demo$} and in {other-source$}. This - by the way -
illustrates links to whole program files.&lt;p&gt;

The functions in meta-demo are {*list-prefix} and its helping function {+list-prefix-1}. Notice first the
strong reference (red) and the weak reference (blue). We may also just make typographic emphasis, like
{-list-prefix-1} (C-e C-w). 
&lt;p&gt;

The functions in {+other-source$} are {*other-source$pair-up} and its helping function {+other-source$pair-up-1}.&lt;p&gt;

At the bottom of {*other-source$} we see a definitions of {+other-source$key-list} and {+other-source$val-list}.
Following these definitions we see {+other-source$aref-assignment}, which in a rather informal way denotes a section
of the program via use of a so-called  &lt;em&gt;sectional comment&lt;/em&gt; in {+other-source$}.

.END

--------------------------------------------------------------------------------

.ENTRY details
.TITLE Discussing details
.BODY
Let us demonstrate the use of source markers in {*fak}.
At @a we test if the parameter is zero. If it is we return the base value 1 (@b).
If not we return n times (fak (- n 1)) (@c); This illustrates the recursion in {+fak}.

.END


--------------------------------------------------------------------------------

.ENTRY the-end
.TITLE The End
.BODY
This ends our simple demonstration of the Scheme elucidator.
.END


</pre></font></td></tr></table>")) ((kind "manual-section") (section-title "Elucidator editor support using Emacs") (section-body "<a name=\"emacs\"> Using Emacs (GNU Emacs on either windows or unix)
                 there exists a substantial support of elucidative programming.
                 The main idea is to keep track of all the files in a bundle, and to help author a documentation bundle in a
                 a safe and convenient way. We support a splitted frame, with documentation in the top-most window, and a program
                 in the bottom window in an Emacs frame.<p>We will now describe the Emacs editor commands which support elucidative programming.
                These are defined in the Emacs lisp file 'elucidator.el' which resides in the same directory
                as the 'elucidator.scm' program (which defines the Elucidator tool).<p><table border = 1><tr><td width = 300 valign = top bgcolor = \"#ffffff\"><b>Command</b></td><td width = 100 valign = top bgcolor = \"#ffffff\"><b>Key binding</b></td><td width = 400 valign = top bgcolor = \"#ffffff\"><b>Effect</b></td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">make-elucidator</td><td width = 100 valign = top bgcolor = \"#ffffff\"><em>none</em></td><td width = 400 valign = top bgcolor = \"#ffffff\">Make the directory structure of a new elucidator and establish a setup file based on
                                            information retrieved via prompting. Also make a template of the documentation file.
                                            As the first thing you should call elucidate on the setup buffer. This will cause the rest of the
                                            files to be created, including the necessary gif icons. Finally you should use setup-elucidator to
                                            make all the elucidator editor buffers, and to prepare for the programming and documentation
                                            process</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">setup-elucidator</td><td width = 100 valign = top bgcolor = \"#ffffff\"><em>none</em></td><td width = 400 valign = top bgcolor = \"#ffffff\">Set up the elucidator on an existing laml setup file, which must be an laml file.
                                                        If f.laml is selected, the textual documentation is assumed to in file f.txt.
                                                        Both files are brought up in editor buffers.</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">refresh-elucidator</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e r</td><td width = 400 valign = top bgcolor = \"#ffffff\">Refresh the program knowledge established by the laml processing
                                                 part of the elucidator. This affect the cross referencing capabilities
                                                 of the editor part, and it (re)defines the source files on which the elucidator
                                                 works. The information is taken from the internal directory.</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">reset-elucidator</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-r</td><td width = 400 valign = top bgcolor = \"#ffffff\">Reestablish a situation where the documentation and program is shown in a two window
                                                configuration, the documentation above the program</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">goto</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e g<br>C-e C-h</td><td width = 400 valign = top bgcolor = \"#ffffff\">A generic navigation command which can be used inside the textual documentation format.
                                                If used inside curly bracket navigate to a program unit. If used in brackets navigate to another
                                                documentation unit. If used on a defined name in the head of a Scheme define form go to
                                                the place this definition is documented. If used on an applied name go to the definition of 
                                                the name.</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">back</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-b</td><td width = 400 valign = top bgcolor = \"#ffffff\">Reverse the effect of the previous goto</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">prog-ref</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-p</td><td width = 400 valign = top bgcolor = \"#ffffff\">Insert a program reference (in curly brackets) in the documentation. Uses completion for entering of
                                                a program identification</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">doc-ref</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-d</td><td width = 400 valign = top bgcolor = \"#ffffff\">Insert a documentation reference (in brackets) in the documentation. Uses completion for entering of
                                                a documentation identification</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">surround-prog-ref</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-q</td><td width = 400 valign = top bgcolor = \"#ffffff\">Surround an identifier with curly brackets in order to make a relation from a place in the documentation
                                              to a program unit. This function is an alternative to prog-ref, in situations where there is 
                                              an existing program unit name in the documentation</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">show-setup</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-u</td><td width = 400 valign = top bgcolor = \"#ffffff\">Show the setup LAML file</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">show-program</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e p</td><td width = 400 valign = top bgcolor = \"#ffffff\">Show a program. You are prompted for one of the programs in the documentation bundle</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">elucidate</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-o</td><td width = 400 valign = top bgcolor = \"#ffffff\">Run the elucidator on the setup file of the current documentation bundle. This command can
                                             be activated from an arbitrary buffer in the documentation bundle</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">save-elucidator-buffers</td><td width = 100 valign = top bgcolor = \"#ffffff\"><em>none</em></td><td width = 400 valign = top bgcolor = \"#ffffff\">Saves all the buffers in the documentation bundle</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">quit-elucidator</td><td width = 100 valign = top bgcolor = \"#ffffff\"><em>none</em></td><td width = 400 valign = top bgcolor = \"#ffffff\">Save elucidator buffers and kill them all. Reset the state of elucidator.</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">elucidator-help</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e ?</td><td width = 400 valign = top bgcolor = \"#ffffff\">Shows brief elucidator help information in Emacs</td></tr></table><p>In addition, we support a number of insert functions which allows template insertion. These functions are all defined
               as part of  LAML emacs lisp template facility. The template insertions commands are:<p><table border = 1><tr><td width = 300 valign = top bgcolor = \"#ffffff\"><b>Command</b></td><td width = 100 valign = top bgcolor = \"#ffffff\"><b>Key binding</b></td><td width = 400 valign = top bgcolor = \"#ffffff\"><b>Effect</b></td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">insert-documentation-intro</td><td width = 100 valign = top bgcolor = \"#ffffff\"><em>none</em></td><td width = 400 valign = top bgcolor = \"#ffffff\">Insert a documentation intro using the textual format</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">insert-documentation-section</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-x</td><td width = 400 valign = top bgcolor = \"#ffffff\">Insert a documentation section using the textual format</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">insert-documentation-entry</td><td width = 100 valign = top bgcolor = \"#ffffff\">C-e C-c</td><td width = 400 valign = top bgcolor = \"#ffffff\">Insert a documentation entry using the textual format</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">insert-lispstyle-documentation-section</td><td width = 100 valign = top bgcolor = \"#ffffff\"><em>none</em></td><td width = 400 valign = top bgcolor = \"#ffffff\">Insert a documentation section using the LAML format</td></tr><tr><td width = 300 valign = top bgcolor = \"#ffffff\">insert-lispstyle-documentation-entry</td><td width = 100 valign = top bgcolor = \"#ffffff\"><em>none</em></td><td width = 400 valign = top bgcolor = \"#ffffff\">Insert a documentation entry using the LAML format</td></tr></table><p>Any command described above is activated by M-x command (i.e., Esc X command) or via the keyboard bindings.
               Notice that the prefix of the elucidator keyboard bindings is C-e. Usually C-e runs the command end-of-line.
               This commands has been moved to C-e C-e when the elucidator is loaded into Emacs.")))